
/* Chrysalide - Outil d'analyse de fichiers binaires
 * operand.h - prototypes pour les opérandes de substitution pour variables
 *
 * Copyright (C) 2009-2017 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _PLUGINS_STACKVARS_OPERAND_H
#define _PLUGINS_STACKVARS_OPERAND_H


#include <glib-object.h>
#include <stdbool.h>


#include <analysis/routine.h>
#include <arch/x86/operand.h>



#define G_TYPE_STACK_VAR_OPERAND                  g_stack_var_operand_get_type()
#define G_STACK_VAR_OPERAND(obj)                  (G_TYPE_CHECK_INSTANCE_CAST((obj), g_stack_var_operand_get_type(), GStackVarOperand))
#define G_IS_STACK_VAR_OPERAND(obj)               (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_stack_var_operand_get_type()))
#define G_STACK_VAR_OPERAND_GET_IFACE(inst)       (G_TYPE_INSTANCE_GET_INTERFACE((inst), g_stack_var_operand_get_type(), GStackVarOperandIface))


/* Définition d'un opérande de substitution pour variable de pile (instance) */
typedef struct _GStackVarOperand GStackVarOperand;

/* Définition d'un opérande de substitution pour variable de pile (classe) */
typedef struct _GStackVarOperandClass GStackVarOperandClass;


/* Indique le type défini pour un opérande de substitution pour variable de pile. */
GType g_stack_var_operand_get_type(void);

/* Crée un opérande de substitution pour variable de pile. */
GArchOperand *g_stack_var_operand_new(const GBinRoutine *, const GX86ModRMOperand *);



#endif  /* _PLUGINS_STACKVARS_OPERAND_H */
